# DreamHost RoundCube Theme (DreamCube)

## Getting Started

These instructions will get you a copy of the project up and running on your local machine for development and testing purposes.



## Run RoundCube Locally

Install Docker (https://www.docker.com/get-started)

```
 docker pull roundcube/roundcubemail
```

Extract roundcube and copy the elastic dir somewhere (that's all
you need).


```
docker run -p 5001:80 -v
/path/to/skins/elastic/:/var/www/html/skins/elastic/ -e
ROUNDCUBEMAIL_DEFAULT_HOST=tls://imap.dreamhost.com -e
ROUNDCUBEMAIL_SMTP_SERVER=tls://smtp.dreamhost.com -e
ROUNDCUBEMAIL_SKIN=elastic -d roundcube/roundcubemail
```

You need to modify the path to the local copy of the elastic dir you
extracted in the command above. So modify this part only:
`/path/to/skins/elastic/`.

That's it! To open up Roundcube type localhost:5001 on your browser and
you will see a working install of Roundcube that logs you into any email
at DH and you can make changes within the local dir and refresh your
browser and see the changes to the theme.

## Theme Development Enviroment

1. cd into `/path/to/skins/elastic/`

2. Install dev dependencies (nodejs & npm must be installed)

```
npm install
```
 
 3. Run webpack

```
npm run build
```

4. Edit `/templates/includes/layout.html`

5. Add livereload.js after `<link rel="stylesheet" href="/deps/bootstrap.min.css">`
```
<script src="http://localhost:3333/livereload.js"></script>
```


6. Comment out the css file
```
<!-- <link rel="stylesheet" href="/styles/styles.css"> -->
```
7. Open `/index.js`

8. Uncomment .less import

```
import './styles/styles.less';
```

9.  Verify it's running

```
localhost:5001
```

## Deployment

1. Undo steps 8, 6, 5

2. Build CSS for deployment

```
npm run less
```


*******


INSTALLATION (Original README)
------------

This skin package contains a theme for the Roundcube Webmail
software. It can be used, modified and redistributed according to
the terms described in the LICENSE section.

For information about building or modifying Roundcube skins please visit
https://github.com/roundcube/roundcubemail/wiki/Skins

All styles are written using LESS syntax. Thus it needs to be compiled
using the `lessc` (>= 1.5.0) command line tool. This comes with the `nodejs-less`
RPM package which depends on nodejs.
```
    $ lessc -x styles/styles.less > styles/styles.css
    $ lessc -x styles/print.less > styles/print.css
    $ lessc -x styles/embed.less > styles/embed.css
```
(the -x option minifies the CSS code)

References to image files from the included CSS files can be appended
with cache-buster marks to avoid browser caching issues after updating.

Run `bin/updatecss.sh --dir skins/elastic` before packaging the skin
or after installing it on the destination system.

