// Webpack uses this to work with directories
const path = require('path');
const LiveReloadPlugin = require('webpack-livereload-plugin');

// This is main configuration object.
// Here you write different options and tell Webpack what to do
module.exports = {

	plugins: [
    new LiveReloadPlugin({port: 3333})
	],
	
  // Path to your entry point. From this file Webpack will begin his work
  entry: './index.js',

  // Path and filename of your result bundle.
  // Webpack will bundle all JavaScript into this file
  output: {
    path: path.resolve(__dirname, 'dist'),
    filename: 'bundle.js'
  },

  // Default mode for Webpack is production.
  // Depending on mode Webpack will apply different things
  // on final bundle. For now we don't need production's JavaScript 
  // minifying and other thing so let's set mode to development
	mode: 'development',
	watch: true,

	
	module: {
    rules: [
      {
        test: /\.less$/,
        use: [
          {
            loader: 'style-loader', // creates style nodes from JS strings
          },
          {
						loader: 'css-loader', // translates CSS into CommonJS
						options: {
							url: false,
							sourceMap: true
						}
          },
          {
						loader: 'less-loader', // compiles Less to CSS
						options: {
							relativeUrls: false,
							sourceMap: true,
						}
          },
        ],
      },
    ],
	},
	
};